using System;
using System.Collections;
using System.Text;
using System.Threading;

namespace AsyncCall
{
    class Work
    {
        public delegate void BinaryOp(int x, int y);

        int answer = 0;
        bool Ready = false;

        void Add(int x, int y)
        {
            Console.WriteLine("Add() invoked on thread {0}.",
                              Thread.CurrentThread.ManagedThreadId);
                // Pause to simulate a lengthy operation.
            Thread.Sleep(1000);
            answer =  x + y;
        }

        void AddComplete(IAsyncResult itfAR)
        {
            Console.WriteLine("AddComplete() invoked on thread {0}.",
            Thread.CurrentThread.ManagedThreadId);
            Console.WriteLine("Your addition is complete");
            Console.WriteLine("10 + 10 is {0}", answer);
            Ready = true;
        }

        public void Run()
        {
            int count = 5;

            Console.WriteLine("Main() invoked on thread {0}.",
                Thread.CurrentThread.ManagedThreadId);

                // Invoke Add() on a secondary thread.
            BinaryOp b = new BinaryOp(Add);
            b.BeginInvoke(10, 10,
                new AsyncCallback(AddComplete), null);
            
            // Do other work on primary thread...               
            while (count-- != 0)
            {
                Console.WriteLine("Doing more work in Main()!");
                Thread.Sleep(500);
            }

            while (!Ready)
            {
                Thread.Sleep(500);
            }
        }
        
    }
       class Program
    {      
        static void Main(string[] args)
        {
          new Work().Run();        
        }
    }
}
 