using System;
using System.Collections;
using System.Text;
using System.Threading;

namespace AsyncDelegate
{
    class Work
    {
        public delegate int BinaryOp(int x, int y);

        int Add(int x, int y)
        {
            Console.WriteLine("Add() invoked on thread {0}.",
                              Thread.CurrentThread.ManagedThreadId);
                // Pause to simulate a lengthy operation.
            Thread.Sleep(2000);
            return x + y;
        }

        public void Run()
        {
            Console.WriteLine("Main() invoked on thread {0}.",
                              Thread.CurrentThread.ManagedThreadId);

                // Invoke Add() on a secondary thread.
            BinaryOp b = new BinaryOp(Add);
            IAsyncResult iftAR = b.BeginInvoke(10, 10, null, null);
                // Do other work on primary thread...
            Console.WriteLine("Doing more work in Main()!");
                // Obtain the result of the Add()
                // method when ready.
/*
            while (!iftAR.IsCompleted)
            {
                Console.WriteLine("Doing more work in Main()!");
                Thread.Sleep(500);
            }
*/ 
            int answer = b.EndInvoke(iftAR);
            Console.WriteLine("10 + 10 is {0}.", answer);           
      
        }
        
    }
       class Program
    {      
        static void Main(string[] args)
        {
          new Work().Run();        
        }
    }
}
 