﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DrawRect
{
    public class Point
    {
        
        public int x;
        public int y;
        
    }

    public class Rectangle
    {
        public Point UpperLeft;
        public Point LowerRight;

        private ConsoleColor Color;

        public Rectangle(ConsoleColor cc)
        {
            Color = cc;
        }

        public void Draw()
        {
            int count;


            Console.Title = "Rectangle [(" + UpperLeft.x.ToString() + ", " 
                                           + UpperLeft.y.ToString() + "), (" 
                                           + LowerRight.x.ToString() + ", " 
                                           + LowerRight.y.ToString() + ")]";
            
            Console.ForegroundColor = Color;

            Console.SetCursorPosition(UpperLeft.x, UpperLeft.y);
            count = LowerRight.x - UpperLeft.x;
            while (count-- > 0)
                Console.Write('-');

            Console.SetCursorPosition(UpperLeft.x, LowerRight.y);
            count = LowerRight.x - UpperLeft.x;
            while (count-- > 0)
                Console.Write('-');

            
            count = LowerRight.y - UpperLeft.y;
            while (count-- >= 0)
            {
                Console.SetCursorPosition(UpperLeft.x, UpperLeft.y + count + 1);
                Console.Write('|');
            }

            count = LowerRight.y - UpperLeft.y;
            while (count-- >= 0)
            {
                Console.SetCursorPosition(LowerRight.x, LowerRight.y - count - 1);
                Console.Write('|');
            }

            Console.ForegroundColor = ConsoleColor.White;
        
        }

    }


    class Program
    {

        static void Main(string[] args)
        {
            int a, b, c;
            string st;

            var ColorList =              // tablica stałych
                Enum.GetValues(ConsoleColor.Black.GetType());

            Console.Write("Podaj wartośc X punktu LewoGóra : ");
            st = Console.ReadLine();
            a = int.Parse(st);

            Console.Write("Podaj wartośc Y punktu LewoGóra : ");
            st = Console.ReadLine();
            b = int.Parse(st);

            Console.Write("Podaj numer koloru : ");
            st = Console.ReadLine();
            c = int.Parse(st);

            if (c < 0 || c >= ColorList.Length)
                c = 5;

            Rectangle r = new Rectangle ((ConsoleColor)ColorList.GetValue(c))
            {
                UpperLeft = new Point { x = a, y = b },
                LowerRight = new Point { x = 50, y = 20 }
            };

            r.Draw();
            Console.WriteLine("\n");
        }
    }
}
