﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;

namespace EwideD
{   
    [Serializable]
    class Komputer
    {
        public double Cena;
        public string Marka;
    }

    delegate void OpFun(ref Komputer[] Tab, ref int ile);

    class Program
    {
        const int N = 100;

        void Op_N(ref Komputer[] Tab, ref int ile)
        {
            string str;
            if (ile == N)
            {
                Console.WriteLine("Tablica pełna.");
                return;
            }
            Tab[ile] = new Komputer();
            Console.Write("\nPodaj markę komputera : ");
            Tab[ile].Marka = Console.ReadLine();
            Console.Write("\nPodaj cenę komputera : ");
            str = Console.ReadLine();
            Tab[ile++].Cena = double.Parse(str);
        }

        void Op_W(ref Komputer[] Tab, ref int ile)
        {
            int licz;
            for (licz = 0; licz < ile; ++licz)
                Console.WriteLine("{0}. M : {1}, C : {2}",
                licz, Tab[licz].Marka, Tab[licz].Cena);
        }

        void Op_U(ref Komputer[] Tab, ref int ile)
        {
            int licz;
            string str;

            Console.Write("\nPodaj numer komputera : ");
            str = Console.ReadLine();
            licz = int.Parse(str);

            if (licz < 0 || licz >= ile)
            {
                Console.WriteLine("Błędny numer komputera.");
                return;
            }

            Tab[licz] = Tab[ile-- - 1];

        }

        void Op_S(ref Komputer[] Tab, ref int ile)
        {
            int licz;
            double Suma = 0;
            for (licz = 0; licz < ile; ++licz)
                Suma += Tab[licz].Cena;
            Console.WriteLine("Suma cen wszystkich komputerów : {0}", Suma);
        }

        void Op_Z(ref Komputer[] Tab, ref int ile)
        {
            string str;
            Console.Write("Podaj nazwę pliku do zapisu : ");
            str = Console.ReadLine();

            FileStream stream = File.Create(str);
            BinaryFormatter form = new BinaryFormatter();

            form.Serialize(stream, ile);
/*
           for (int licz = 0; licz < ile; ++licz)
                form.Serialize(stream, Tab[licz]);
 */ 
           form.Serialize(stream, Tab);

            Console.WriteLine("Zapisano.");
            stream.Close();

        }

        void Op_O(ref Komputer[] Tab, ref int ile)
        {
            string str;
            FileInfo ff;

            Console.Write("Podaj nazwę pliku do odczytu : ");
            str = Console.ReadLine();
            ff = new FileInfo(str);
            if (!ff.Exists)
            {
                Console.WriteLine("Błędna nazwa pliku.");
                return;
            }


            FileStream stream = File.OpenRead(str);
            BinaryFormatter form = new BinaryFormatter();
            
            ile = (int)form.Deserialize(stream);
/*
            for (int licz = 0; licz < ile; ++licz)
            {
                Tab[licz] = (Komputer)form.Deserialize(stream);
            }
*/
            Tab = (Komputer[])form.Deserialize(stream);
            
            
            
            Console.WriteLine("Odczytano.");
            stream.Close();

        }

        void Bieg()
        {
            Komputer[] TabKomp = new Komputer[N];
            int ile = 0;
            char opcja = 'X';
            string str;

            Dictionary<char, OpFun> LiFu = new Dictionary<char, OpFun>();
            LiFu.Add('N', new OpFun(Op_N));
            LiFu.Add('W', new OpFun(Op_W));
            LiFu.Add('U', new OpFun(Op_U));
            LiFu.Add('S', new OpFun(Op_S));
            LiFu.Add('Z', new OpFun(Op_Z));
            LiFu.Add('O', new OpFun(Op_O));



            while ((opcja) != 'Q')
            {
                Console.Write("\nWybierz opcję [N,W,U,S,Z,O,Q] : ");
                str = Console.ReadLine();
                opcja = (char)(str[0] & 0x5F);

                if (LiFu.ContainsKey(opcja))
                    (LiFu[opcja])(ref TabKomp, ref ile);
                else
                    if (opcja != 'Q')
                        Console.WriteLine("Zła opcja");
                    else
                        Console.WriteLine("\nKoniec programu.\n");
            }
         

        }
        static void Main(string[] args)
        {
            new Program().Bieg();
        }
    }
}
