using System;
using System.Collections;
using System.Text;

namespace Komis
{
    public interface Monitor
    {
        void Wyswietl();
    }

    class Narty : Monitor, IComparable
    {
        private int Cena;
        private char Klasa;     //A, B, C
        private int Numer;

        public Narty (int nu, int ce, char kl)
        {
            Numer = nu;
            Cena = ce;
            Klasa = kl;
        }

        public void Wyswietl()
        {
              Console.WriteLine("Nr : {0}, Klasa : {1}, Cena : {2}",
                                  Numer, Klasa, Cena );
        }

        public int CompareTo(Object ob)
        {
            Narty temp = (Narty)ob;
            if (this.Klasa > temp.Klasa)
                return 1;
            if (temp.Klasa > this.Klasa)
                return -1;
            if (this.Cena < temp.Cena)
                return 1;
            if (temp.Cena < this.Cena)
                return -1;
            return 0;
        }
    }

    class Rower : Monitor, IComparable
    {
        private int Cena;
        private double Ciezar;
        private int Numer;

        public Rower(int nu, int ce, double ci)
        {
            Numer = nu;
            Cena = ce;
            Ciezar = ci;
        }

        public void Wyswietl()
        {
                Console.WriteLine("Nr : {0}, Ciezar : {1}, Cena : {2}",
                                  Numer, Ciezar, Cena);
        }
        public int CompareTo(Object ob)
        {
            Rower temp = (Rower)ob;
            if (this.Ciezar > temp.Ciezar)
                return 1;
            if (temp.Ciezar > this.Ciezar)
                return -1;
            if (this.Cena < temp.Cena)
                return 1;
            if (temp.Cena < this.Cena)
                return -1;
            return 0;
        }

    }

    class Program
    {
        static void Main(string[] args)
        {
            new Program().Start();
        }

        private void Start()
        {
            
            ArrayList RR = new ArrayList();
            ArrayList NN = new ArrayList();

            RR.Add(new Rower(1,500,8));
            RR.Add(new Rower(2,350,12));
            RR.Add(new Rower(3,400,8));

            NN.Add(new Narty(1, 200, 'A'));
            NN.Add(new Narty(2, 150, 'B'));
            NN.Add(new Narty(3, 400, 'A'));

            RR.Sort();
            NN.Sort();

            Pokaz(RR);
            Pokaz(NN);

            Console.WriteLine();
 
        }

        private void Pokaz(ArrayList AA)
        {
            int i;
            Monitor mm;

            Console.WriteLine();
            for (i = 0; i < AA.Count; ++i)
            {
                mm = AA[i] as Monitor;
                mm.Wyswietl();
            }
                
        }
    }
}
