using System;
using System.Collections.Generic;
using System.Text;

namespace Lambda
{ 
    // Deklaracje delegacji

    public delegate double Fun1(double x);
    public delegate double Fun2(double x, double y);
    public delegate double Fun3(double[] Arr);

    class Program
    {
        // Funkcje Oblicz przetwarzaj tablic bdc 1. argumentem za pomoc
        // funkcji zawartej w obiekcie delegacji bdcym 2. argumentem

        void Oblicz1(double[] Tab, Fun1 f1)
        {
           for (int i = 0; i < Tab.Length; ++i)
                Tab[i] = f1(Tab[i]);
        }

        void Oblicz2(double[] Tab, Fun2 f2)
        {
            for (int i = 1; i < Tab.Length; ++i)
                Tab[i] = f2(Tab[i], Tab[0]);
        }


        double Oblicz3(double[] Tab, Fun3 f3)
        {
            return f3(Tab);
        }


        void Pokaz(double[] Tab)
        {
            Console.WriteLine();
            foreach(double a in Tab)
                Console.Write("{0,8:F2}", a);
            Console.WriteLine();
        }


        void Start()
        {
            double[] Tablica = {10, 17, 4, -5, 28, -9};
            double w;

            // wywoanie z delegacj Fun1

            Oblicz1(Tablica, x => x - 5);   
            Pokaz(Tablica);
            Console.ReadLine();


            // wywoanie z delegacj Fun1

            Oblicz1(Tablica, x => x >= 0 ? Math.Sqrt(x) : x);
            Pokaz(Tablica);
            Console.ReadLine();

            // wywoanie z delegacj Fun2

            Oblicz2(Tablica, (x, y) => x + y);
            Pokaz(Tablica);
            Console.ReadLine();


            // wywoanie z delegacj Fun2

            Oblicz2(Tablica, (x, y) =>
                                      {
                                        int z = Math.Abs((int)(x + y));
                                        for (int i = 1; i < z; ++i)
                                            x += y / i;
                                        return x;
                                      }
                   );
            Pokaz(Tablica);
            Console.ReadLine();

            // wywoanie z delegacj Fun3

            w = Oblicz3(Tablica, Taba =>
                                       {
                                          return Taba[0] + Taba[Taba.Length - 1];
                                       }
                       );

            Console.WriteLine("\n{0,8:F2}\n",w);

        }





        static void Main(string[] args)
        {
            new Program().Start();
        }
    }
}
/*

        void Start()
        {
            double[]Tablica = {10, 17, 4, -5, 28, -9};
            double w;

            // wywoanie z delegacj Fun1

            Oblicz1(Tablica, x => x - 5);   
            Pokaz(Tablica);
            // wynik: 5,00 12,00 -1,00 -10,00 23,00 -14,00

            // wywoanie z delegacj Fun1

            Oblicz1(Tablica, x => x >= 0 ? Math.Sqrt(x) : x);
            Pokaz(Tablica);
            // wynik: 2,24 3,46 -1,00 -10,00 4,80 -14,00
            Console.ReadLine();

            // wywoanie z delegacj Fun2

            Oblicz2(Tablica, (x, y) => x + y);
            Pokaz(Tablica);
            // wynik: 2,24 5,70 1,24 -7,76 7,03 -11,76

            // wywoanie z delegacj Fun2

            Oblicz2(Tablica, (x, y) =>
                                    {
                                        int z = (int)(x + y);
                                        for (int i = 1; i < z; ++i)
                                            x += y / i;
                                        return x;
                                    }
                   );
            Pokaz(Tablica);
            // wynik: 2,24 32,49 1,53 60,28 49,45 138,39

            // wywoanie z delegacj Fun3

            w = Oblicz3(Tablica, Taba =>
                {
                   return Taba[0] + Taba[Taba.Length - 1];
                }
                       );
            // wynik: 140,63
            Console.WriteLine();
            Console.WriteLine("{0,8:F2}",w);
*/