﻿// Jacek Matulewski
// ftp://ftp.helion.pl/przyklady/cshtec.zip

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Linq1
{
    class Osoba
    {
        public int Id;
        public string Imie;
        public string Nazwisko;
        public long Pesel;
        public int Wiek;
        public override string ToString()
        {
            return
                Id + ": " + Imie + " " + Nazwisko + ", " + Pesel + ", " + Wiek + ".";
        }
    }

    
    
    class Program
    {
        void Start()
        {
            List<Osoba> ListaOsob = new List<Osoba>()
            {
                new Osoba {Id = 10, Imie = "Anna", Nazwisko = "Kowalska", Pesel = 73011101122, Wiek = 35},
                new Osoba {Id = 11, Imie = "Andrzej", Nazwisko = "Potemski", Pesel = 08221502233, Wiek = 5},
                new Osoba {Id = 12, Imie = "Ryszard", Nazwisko = "Konik", Pesel = 80030303333, Wiek = 28},
                new Osoba {Id = 13, Imie = "Zofia", Nazwisko = "Miła", Pesel = 91040404444, Wiek = 17},
                new Osoba {Id = 14, Imie = "Maciej", Nazwisko = "Ptak", Pesel = 56050505555, Wiek = 52},
                new Osoba {Id = 15, Imie = "Adam", Nazwisko = "Olski", Pesel = 94060606656, Wiek = 14}

            };

            
// pobranie całych obiektów
         
 
                        var Pelnoletni = from osoba in ListaOsob
                                       where osoba.Wiek >= 18   // orderby osoba.Wiek descending
                                       select osoba;

                        foreach (var osoba in Pelnoletni)
                                Console.WriteLine(osoba);

                        Console.WriteLine();
          


// pobieranie danych do kolekcji
/*        
  
            long[] Pesel;
            
            var ListaPesel = from osoba in ListaOsob
                             select osoba.Pesel;

            Pesel = ListaPesel.ToArray<long>();     // ToList<>() ,  ToDictionary<>() , <int>

            foreach (long pp in Pesel)
                Console.WriteLine(pp.ToString());

            Console.WriteLine();

*/
// pobranie wybranych danych z wybranych obiektów
/*

                        var Pelnoletni = from osoba in ListaOsob
                                         where osoba.Wiek >= 18
                                         orderby osoba.Wiek
                                         select
                                             new { osoba.Imie, osoba.Nazwisko, osoba.Wiek };

                        foreach (var osoba in Pelnoletni)
                                   Console.WriteLine("{0} {1} => {2}", osoba.Imie, osoba.Nazwisko, osoba.Wiek);
 
                                    Console.WriteLine(); 

*/
// przetwarzanie danych z wybranych obiektów
/*
            var Niepelnoletni = from osoba in ListaOsob
                             where osoba.Wiek < 18
                              select osoba;

            Console.WriteLine("Najstarszy: {0}",
                Niepelnoletni.Max(osoba => osoba.Wiek));

            Console.WriteLine("Średni: {0}",
                Niepelnoletni.Average(osoba => osoba.Wiek));
 
            Console.WriteLine("Suma: {0}\n",
                Niepelnoletni.Sum(osoba => osoba.Wiek));
 
*/
// wyszukanie 1 obiektu z wybranych obiektów
/*           
            var Niepelnoletni = from osoba in ListaOsob
                                where osoba.Wiek <= 18
                                select osoba;
                                                            
            var Najstarszy = Niepelnoletni.Single(              
                       os1 => (os1.Wiek == Niepelnoletni.Max(os2 => os2.Wiek)));   // gdy wielu wyjątek

     //       int MaxWiek = Niepelnoletni.Max(os2 => os2.Wiek);
     //       var Najstarszy = Niepelnoletni.Single(os1 => (os1.Wiek == MaxWiek));


            Console.WriteLine("Najstarsza osoba z niepełnoletnich => {0}\n", Najstarszy.ToString());

*/
// testowanie danych
/*          
            var Niepelnoletni = from osoba in ListaOsob
                                where osoba.Wiek < 18
                                select osoba;

            bool TylkoDzieci = Niepelnoletni.All(osoba => osoba.Wiek < 10);   // Any, Contains

            Console.WriteLine("Tylko dzieci : " + TylkoDzieci.ToString());

*/
// operacje na zbiorach danych
/*
            var listaPelnoletnich = from osoba in ListaOsob 
                                        where osoba.Wiek >= 18 orderby osoba.Wiek 
                                        select new { osoba.Imie, osoba.Nazwisko, osoba.Wiek };

            var listaKobiet = from osoba in ListaOsob 
                              where osoba.Imie.EndsWith("a") 
                              select new { osoba.Imie, osoba.Nazwisko, osoba.Wiek };

            var listaPelnoletnich_lub_Kobiet = listaPelnoletnich.Union(listaKobiet);   // Intersect, Except 

            Console.WriteLine("Lista osób pełnoletnich lub kobiet (suma zbiorów)\n");
            foreach (var osoba in listaPelnoletnich_lub_Kobiet) 
                Console.WriteLine(osoba.Imie + " " + osoba.Nazwisko + " " + osoba.Wiek + "\n");
*/
// pobieranie danych z dwóch źródeł
/*

            var listaPesel = from osoba in ListaOsob 
                             select new { osoba.Id, osoba.Pesel };

            var listaPerson = from osoba in ListaOsob 
                              select new { osoba.Id, osoba.Imie, osoba.Nazwisko };

            var listaPersonZPeselem = from pesel in listaPesel 
                                      join persona in listaPerson 
                                      on pesel.Id equals persona.Id 
                                      select new { pesel.Id, persona.Imie, persona.Nazwisko, pesel.Pesel };

            Console.WriteLine("Pobieranie danych z dwóch źródeł - operator join:\n");
            foreach (var osoba in listaPersonZPeselem) 
                Console.WriteLine(osoba.Imie + " " + osoba.Nazwisko + " " + osoba.Pesel + "\n");
*/
// aktualizacja danych
/*
            Console.WriteLine("Lista wszystkich osób:\n");
            foreach (var osoba in ListaOsob)
                Console.WriteLine(osoba.ToString());
 

            var listaOsobPelnoletnich = from osoba in ListaOsob 
                                        where osoba.Wiek >= 18 
                                        orderby osoba.Wiek 
                                        select osoba;
            

            Osoba pierwszyNaLiscie = listaOsobPelnoletnich.First<Osoba>();
            pierwszyNaLiscie.Imie = "Tomasz";
            pierwszyNaLiscie.Nazwisko = "Koperski";


            Console.WriteLine("\n\nUaktualniona lista wszystkich osób:\n");
            foreach (var osoba in ListaOsob)
                Console.WriteLine(osoba.ToString());
  
*/
// grupowanie danych
/*
            string[] words = { "blueberry", "chimpanzee", "abacus", 
                                "banana", "apple", "cheese" };

            var wordGroups =        // IEnumerable<IGrouping<char, string>>
                from w in words
                group w by  w[0] into g // w.Length                       
                select new { FirstLetter = g.Key, Words = g };  
     // g -> IGrouping<char, string>> : IEnumerable<string>
     // g -> {Key, List_of_Strings_with_the_Key}

            foreach (var h in wordGroups)
            {
                Console.WriteLine("Words that start with the letter '{0}':", h.FirstLetter);
                foreach (var w in h.Words)
                {
                    Console.WriteLine(w);
                }
            }

*/            

    }
        static void Main(string[] args)
        {
            new Program().Start();
        }
    }
}
