﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using System.Threading.Tasks;
//using System.PLinq;

namespace ParLinq
{
    class Work
    {
        const int N = 10000000;
        const int div = 54473;
        private int[] source = new int[N];
        private int[] modIsZero = null;
        private CancellationTokenSource cancelToken =
                new CancellationTokenSource();


        public void Run()
        {
            DateTime dt;
            TimeSpan ts1, ts2;
            Random rd = new Random((int)DateTime.Now.Ticks);

            for (int i = 0; i < N; ++i)
                source[i] = rd.Next(N);
            
 //           cancelToken.Cancel();
            dt = DateTime.Now;
    
            try
            {
                modIsZero = 
                 (from num in source.AsParallel().WithCancellation(cancelToken.Token)
                  where Math.Floor(Math.Cos(num)*N) % div == 0 
                  orderby num descending
                  select num).ToArray();
            }
                catch (OperationCanceledException ex)
                {
                    Console.WriteLine( ex.Message );
                }

            ts1 = DateTime.Now - dt;

            dt = DateTime.Now;

            modIsZero =
                 (from num in source
                  where Math.Floor(Math.Cos(num) * N) % div == 0
                  orderby num descending
                  select num).ToArray();
            
            

            ts2 = DateTime.Now - dt;


            Console.WriteLine("Par = " + ts1.Seconds + ":" + ts1.Milliseconds + "\n");
            Console.WriteLine("Seq = " + ts2.Seconds + ":" + ts2.Milliseconds + "\n");

            foreach (int val in modIsZero)
                Console.WriteLine(val);
        }
            
    }
    
    class Program
    {
        static void Main(string[] args)
        {
            new Work().Run();
        }
    }
}
