﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using System.Threading.Tasks;

namespace TaskPara
{
    class Work
    {
        string[] words;

        public void Run()
        {
            StreamReader sr = new StreamReader("MartinEden.txt", Encoding.ASCII);
          
            string all = sr.ReadToEnd();

            sr.Close();

            string[] words = all.Split(new char[] 
            { ' ','\u000D', '\u000A', ',', '.', ';', ':', '-', '?', '/' },
            StringSplitOptions.RemoveEmptyEntries);

//            string[] words1 = (string[])words.Clone();

            string[] tenMostCommon = null;
            string longestWord = "";
            
            TimeSpan ts;
            DateTime dt1;

            Console.WriteLine("Start ... ");

            dt1 = DateTime.Now;

            // Now, find the ten most common words.
            tenMostCommon = FindTenMostCommon(words);

            // Get the longest word.
            longestWord = FindLongestShortestWord(words);

            /*
                        // Now, find the ten most common words
                        // and get the longest word.
                        Parallel.Invoke(
                            () =>
                            {longestWord = FindLongestShortestWord(words);},
                            () =>
                            {tenMostCommon = FindTenMostCommon(words1);}
                            );
            */
            ts = DateTime.Now - dt1;

            // Now that all tasks are complete, 
            // build a string to show results
            StringBuilder bookStats = new StringBuilder("Ten Most Common Words are:\n");
            foreach (string s in tenMostCommon)
            {
                bookStats.AppendLine(s);
            }
            bookStats.AppendFormat("Longest - Shortest words are: {0}", longestWord);
            bookStats.AppendLine();
            Console.WriteLine("Book info : {0}", bookStats.ToString());
            Console.WriteLine("Total {1},{0} s.\n", ts.Milliseconds, ts.Seconds);
        }

        private string[] FindTenMostCommon(string[] words)
        {
            var frequencyOrder = from word in words
                                // where word.Length > 6
                                 group word by word into g
                                 orderby g.Count() descending
                                 select g.Key;
            string[] commonWords = (frequencyOrder.Take(10)).ToArray();
            return commonWords;
        }

        private string FindLongestShortestWord(string[] words)
        {
            var ll = from w in words orderby w.Length descending select w;
            string st = ll.First();
            var kk = from w in words orderby w.Length ascending select w;
            return st + " - " + kk.First();
        }
    }
    
    class Program
    {
        static void Main(string[] args)
        {
            new Work().Run();
        }
    }
}
