using System;
using System.Collections.Generic;
using System.Text;

namespace Druki
{
    class Wydawnictwo
    {
        public string Tytul;
        protected int Cena;

        public virtual void Wczytaj()
        {
            string str;

            Console.Write("Podaj tytu : ");
            Tytul = Console.ReadLine();

            Console.Write("Podaj cen : ");
            str = Console.ReadLine();
            Cena = int.Parse(str);
        }

        public virtual void Wyswietl()
        {
            Console.WriteLine("Tytu : {0} \nCena  : {1}", Tytul, Cena);
        }

        public static bool operator & (Wydawnictwo ww, int lim)
        {
            if (ww.Cena >= lim - 5 && ww.Cena <= lim + 5)
                return true;
            else
                return false;
        }

    }

    class Ksiazka : Wydawnictwo
    {
        string Autor;

        public override void Wczytaj()
        {
            base.Wczytaj();
            Console.Write("Podaj autora : ");
            Autor = Console.ReadLine();
        }

        public override void Wyswietl()
        {
            base.Wyswietl();
            Console.WriteLine("Autor : {0}\n", Autor);
        }
    }

    class Czasopismo : Wydawnictwo
    {
        string Okres;

        public override void Wczytaj()
        {
            base.Wczytaj();
            Console.Write("Podaj okres : ");
            Okres = Console.ReadLine();
        }

        public override void Wyswietl()
        {
            base.Wyswietl();
            Console.WriteLine("Okres : {0}\n", Okres);
        }
    }

    class Program
    {
        void Start()
        {
            bool dalej = true;
            string str;
            int ile = 0, lim;

            Wydawnictwo[] Kiosk = new Wydawnictwo[100];

            while (dalej)
            {
                Console.WriteLine("\nWybierz opcj [k,c,l,w,x] : ");
                str = Console.ReadLine();

                switch (str[0])
                {
                    case 'k':
                        Kiosk[ile] = new Ksiazka();
                        Kiosk[ile++].Wczytaj();
                        break;
                    case 'c':
                        Kiosk[ile] = new Czasopismo();
                        Kiosk[ile++].Wczytaj();
                        break;
                    case 'l':
                        Console.WriteLine("Podaj limit ceny : ");
                        str = Console.ReadLine();
                        lim = int.Parse(str);

                        for (int i = 0; i < ile; ++i)
                            if (Kiosk[i] & lim)
                                Kiosk[i].Wyswietl();
                        break;
                    case 'w':
                        for (int i = 0; i < ile; ++i)
                            Kiosk[i].Wyswietl();
                        break;
                    case 'x':
                        dalej = false;
                        break;
                    default:
                        Console.WriteLine("Za opcja.");
                        break;
                }



            }
       
        }

        
        static void Main(string[] args)
        {
            new Program().Start();
        }
    }
}
